#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include "can.h"
#include "config.h"


can_t msg; 				// erzeuge eine Testnachricht

can_filter_t filter =
		{				// erzeuge einen Filter (alle Nachrichten)
	    .id = 0,
	    .mask = 0,
	    .flags =	{
					.rtr = 0
					}
		};
		
/********************************************************************
********************************************************************/

int main(void)
{
    // initialisieren des CAN-Busses
    can_init(BITRATE_500_KBPS);
	
	//Filter setzen
	can_set_filter(0, &filter);

	// enable global interrupts
	sei();

	//Verndern der Message zur Laufzeit
	msg.id = 0x202;
	msg.flags.rtr = 0;
   	msg.length = 8;
	msg.data[0] = 0x06;
	msg.data[1] = 0x00;
	msg.data[2] = 0x00;
	msg.data[3] = 0x00;
	msg.data[4] = 0x00;
	msg.data[5] = 0x00;
	msg.data[6] = 0x00;
	msg.data[7] = 0x00;

	// Nachricht verschicken
	can_send_message(&msg);


	//Switch On + Enable Operation; Drehzahl 0
	msg.id = 0x202;
	msg.flags.rtr = 0;
	msg.length = 8;
	msg.data[0] = 0x0F;
	msg.data[1] = 0x00;
	msg.data[2] = 0x00;
	msg.data[3] = 0x00;
	msg.data[4] = 0x00;
	msg.data[5] = 0x00;
	msg.data[6] = 0x00;
	msg.data[7] = 0x00;
	
	// Nachricht verschicken
	can_send_message(&msg);



	//Switch On + Enable Operation; Drehzahl 1000rpm
	msg.id = 0x202;
	msg.flags.rtr = 0;
	msg.length = 8;
	msg.data[0] = 0x0F;
	msg.data[1] = 0x00;
	msg.data[2] = 0x00;
	msg.data[3] = 0x00;
	msg.data[4] = 0x02;
	msg.data[5] = 0x22;
	msg.data[6] = 0x2D;
	msg.data[7] = 0x00;
	
	// Nachricht verschicken
	can_send_message(&msg);

    while (1) 
		{
		;
	    }
}
